ext4: add dump/restore test
[xfstests-dev.git] / common / config
1 ##/bin/bash
2 #
3 # Copyright (c) 2000-2003,2006 Silicon Graphics, Inc.  All Rights Reserved.
4 #
5 # This program is free software; you can redistribute it and/or
6 # modify it under the terms of the GNU General Public License as
7 # published by the Free Software Foundation.
8 #
9 # This program is distributed in the hope that it would be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write the Free Software Foundation,
16 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
17 #
18 #
19 # setup and check for config parameters, and in particular
20 #
21 # EMAIL -           email of the script runner.
22 # TEST_DIR -        scratch test directory that is in an already
23 #                   mounted XFS file system, needs to be be world
24 #                   writeable
25 # TEST_DEV -        device for file system containing TEST_DIR
26 #
27 # and optionally:
28 # SCRATCH_DEV -     device you can make a scratch file system on
29 # SCRATCH_MNT -     mount point for scratch file system
30 # SCRATCH_LOGDEV -  scratch log device for external log testing
31 # SCRATCH_RTDEV -   scratch rt dev
32 # TEST_LOGDEV -     test log device for external log testing
33 # TEST_RTDEV -      test rt dev
34 # TAPE_DEV -        the tape device for the xfsdump tests
35 # RMT_TAPE_DEV -    the remote tape device for the xfsdump tests
36 # RMT_IRIXTAPE_DEV- the IRIX remote tape device for the xfsdump tests
37 # RMT_TAPE_USER -   remote user for tape device
38 #
39 # - These can be added to $HOST_CONFIG_DIR (witch default to ./config)
40 #   below or a separate local configuration file can be used (using
41 #   the HOST_OPTIONS variable).
42 # - This script is shared by the stress test system and the auto-qa
43 #   system
44 # - TEST_DEV & TEST_DIR must be assigned.
45 # - this script shouldn't make any assertions about filesystem
46 #   validity or mountedness.
47 #
48
49 # all tests should use a common language setting to prevent golden
50 # output mismatches.
51 export LANG=C
52 export LC_ALL=C
53
54 # Warning: don't put freeware before /usr/bsd on IRIX coz you'll
55 #  get the wrong hostname and set your system name to -s  :)
56 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
57 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
58 PATH=".:$PATH"
59
60 export HOST=`hostname -s`
61 export HOSTOS=`uname -s`
62 [ "$HOSTOS" = "IRIX64" ] && export HOSTOS="IRIX"
63
64 export MODULAR=0               # using XFS as a module or not
65 export BOOT="/boot"            # install target for kernels
66 export EXTRA=${EXTRA:=xfs-qa}
67
68 # general parameters (mainly for auto-qa)
69 export SOAK_PROC=3             # -p option to fsstress
70 export SOAK_STRESS=10000       # -n option to fsstress
71 export SOAK_PASSES=-1          # count of repetitions of fsstress (while soaking)
72 export EMAIL=root@localhost    # where auto-qa will send its status messages
73 export HOST_OPTIONS=${HOST_OPTIONS:=local.config}
74 export CHECK_OPTIONS=${CHECK_OPTIONS:="-g auto"}
75 export BENCH_PASSES=${BENCH_PASSES:=5}
76 export XFS_MKFS_OPTIONS=${XFS_MKFS_OPTIONS:=-bsize=4096}
77 export TIME_FACTOR=${TIME_FACTOR:=1}
78 export LOAD_FACTOR=${LOAD_FACTOR:=1}
79 export DEBUGFS_MNT=${DEBUGFS_MNT:="/sys/kernel/debug"}
80
81 export PWD=`pwd`
82 #export DEBUG=${DEBUG:=...} # arbitrary CFLAGS really.
83 export MALLOCLIB=${MALLOCLIB:=/usr/lib/libefence.a}
84 export LOCAL_CONFIGURE_OPTIONS=${LOCAL_CONFIGURE_OPTIONS:=--enable-readline=yes}
85
86 export RECREATE_TEST_DEV=false
87
88 # $1 = prog to look for, $2* = default pathnames if not found in $PATH
89 set_prog_path()
90 {
91     p=`which $1 2> /dev/null`
92     if [ -n "$p" -a -x "$p" ]; then
93         echo $p
94         return 0
95     fi
96     p=$1
97
98     shift
99     for f; do
100         if [ -x $f ]; then
101             echo $f
102             return 0
103         fi
104     done
105
106     echo ""
107     return 1
108 }
109
110 # Handle mkfs.btrfs which does (or does not) require -f to overwrite
111 set_btrfs_mkfs_prog_path_with_opts()
112 {
113         p=`set_prog_path mkfs.btrfs`
114         if [ "$p" != "" ] && grep -q 'force overwrite' $p; then
115                 echo "$p -f"
116         else
117                 echo $p
118         fi
119 }
120
121 _fatal()
122 {
123     echo "$*"
124     status=1
125     exit 1
126 }
127
128 export MKFS_PROG="`set_prog_path mkfs`"
129 [ "$MKFS_PROG" = "" ] && _fatal "mkfs not found"
130
131 export MOUNT_PROG="`set_prog_path mount`"
132 [ "$MOUNT_PROG" = "" ] && _fatal "mount not found"
133
134 export UMOUNT_PROG="`set_prog_path umount`"
135 [ "$UMOUNT_PROG" = "" ] && _fatal "umount not found"
136
137 export FSSTRESS_PROG="./ltp/fsstress"
138 [ ! -x $FSSTRESS_PROG ] && _fatal "fsstress not found or executable"
139
140 export PERL_PROG="`set_prog_path perl`"
141 [ "$PERL_PROG" = "" ] && _fatal "perl not found"
142
143 export AWK_PROG="`set_prog_path awk`"
144 [ "$AWK_PROG" = "" ] && _fatal "awk not found"
145
146 export SED_PROG="`set_prog_path sed`"
147 [ "$SED_PROG" = "" ] && _fatal "sed not found"
148
149 export BC_PROG="`set_prog_path bc`"
150 [ "$BC_PROG" = "" ] && _fatal "bc not found"
151
152 export PS_ALL_FLAGS="-ef"
153
154 export DF_PROG="`set_prog_path df`"
155 [ "$DF_PROG" = "" ] && _fatal "df not found"
156 [ "$HOSTOS" = "Linux" ] && export DF_PROG="$DF_PROG -T -P"
157
158 export XFS_LOGPRINT_PROG="`set_prog_path xfs_logprint`"
159 export XFS_REPAIR_PROG="`set_prog_path xfs_repair`"
160 export XFS_DB_PROG="`set_prog_path xfs_db`"
161 export XFS_GROWFS_PROG=`set_prog_path xfs_growfs`
162 export XFS_IO_PROG="`set_prog_path xfs_io`"
163 export XFS_PARALLEL_REPAIR_PROG="`set_prog_path xfs_prepair`"
164 export XFS_PARALLEL_REPAIR64_PROG="`set_prog_path xfs_prepair64`"
165 export __XFSDUMP_PROG="`set_prog_path xfsdump`"
166 if [ -n "$__XFSDUMP_PROG" ]; then
167         export XFSDUMP_PROG="$__XFSDUMP_PROG -e"
168 else
169         export XFSDUMP_PROG=""
170 fi
171 export XFSRESTORE_PROG="`set_prog_path xfsrestore`"
172 export XFSINVUTIL_PROG="`set_prog_path xfsinvutil`"
173 export GETFATTR_PROG="`set_prog_path getfattr`"
174 export SETFATTR_PROG="`set_prog_path setfattr`"
175 export CHACL_PROG="`set_prog_path chacl`"
176 export ATTR_PROG="`set_prog_path attr`"
177 export QUOTA_PROG="`set_prog_path quota`"
178 export XFS_QUOTA_PROG="`set_prog_path xfs_quota`"
179 export KILLALL_PROG="`set_prog_path killall`"
180 export INDENT_PROG="`set_prog_path indent`"
181 export XFS_COPY_PROG="`set_prog_path xfs_copy`"
182 export FSTRIM_PROG="`set_prog_path fstrim`"
183 export DUMPE2FS_PROG="`set_prog_path dumpe2fs`"
184 export FIO_PROG="`set_prog_path fio`"
185 export FILEFRAG_PROG="`set_prog_path filefrag`"
186 export E4DEFRAG_PROG="`set_prog_path e4defrag`"
187 export LOGGER_PROG="`set_prog_path logger`"
188 export DBENCH_PROG="`set_prog_path dbench`"
189 export DMSETUP_PROG="`set_prog_path dmsetup`"
190 export WIPEFS_PROG="`set_prog_path wipefs`"
191 export DUMP_PROG="`set_prog_path dump`"
192 export RESTORE_PROG="`set_prog_path restore`"
193
194 # Generate a comparable xfsprogs version number in the form of
195 # major * 10000 + minor * 100 + release
196 #
197 # $ xfs_db -V
198 # xfs_db version 2.9.7
199 #
200 # so, 2.9.7 = 20907
201 _version=`$XFS_DB_PROG -V | $AWK_PROG '
202         /version/ {
203                 if (split($3,ver,".") == 3)
204                         print (ver[1] * 10000) + (ver[2] * 100) + ver[3];
205         }'`
206 [ -z "$_version" ] && _fatal "xfsprogs version cannot be found"
207 export XFSPROGS_VERSION="$_version"
208
209 case "$HOSTOS" in
210     IRIX*)
211         export MKFS_XFS_PROG="`set_prog_path mkfs_xfs`"
212         export MKFS_UDF_PROG="`set_prog_path mkfs_udf`"
213         export XFS_FSR_PROG="`set_prog_path /usr/etc/fsr_xfs`"
214         export MKFS_NFS_PROG="false"
215         export MKFS_CIFS_PROG="false"
216         ;;
217     Linux)
218         export MKFS_XFS_PROG="`set_prog_path mkfs.xfs`"
219         export MKFS_EXT4_PROG="`set_prog_path mkfs.ext4`"
220         export MKFS_UDF_PROG="`set_prog_path mkudffs`"
221         export MKFS_BTRFS_PROG="`set_btrfs_mkfs_prog_path_with_opts`"
222         export BTRFS_UTIL_PROG="`set_prog_path btrfs`"
223         export BTRFS_SHOW_SUPER_PROG="`set_prog_path btrfs-show-super`"
224         export XFS_FSR_PROG="`set_prog_path xfs_fsr`"
225         export MKFS_NFS_PROG="false"
226         export MKFS_CIFS_PROG="false"
227         ;;
228 esac
229
230 # SELinux adds extra xattrs which can mess up our expected output.
231 # So, mount with a context, and they won't be created
232 # # nfs_t is a "liberal" context so we can use it.
233 if [ -x /usr/sbin/selinuxenabled ] && /usr/sbin/selinuxenabled; then
234         SELINUX_MOUNT_OPTIONS="-o context=system_u:object_r:nfs_t:s0"
235         export SELINUX_MOUNT_OPTIONS
236 fi
237
238 _mount_opts()
239 {
240         case $FSTYP in
241         xfs)
242                 export MOUNT_OPTIONS=$XFS_MOUNT_OPTIONS
243                 ;;
244         udf)
245                 export MOUNT_OPTIONS=$UDF_MOUNT_OPTIONS
246                 ;;
247         nfs)
248                 export MOUNT_OPTIONS=$NFS_MOUNT_OPTIONS
249                 ;;
250         cifs)
251                 export MOUNT_OPTIONS=$CIFS_MOUNT_OPTIONS
252                 ;;
253         ext2|ext3|ext4|ext4dev)
254                 # acls & xattrs aren't turned on by default on ext$FOO
255                 export MOUNT_OPTIONS="-o acl,user_xattr $EXT_MOUNT_OPTIONS"
256                 ;;
257         reiserfs)
258                 # acls & xattrs aren't turned on by default on reiserfs
259                 export MOUNT_OPTIONS="-o acl,user_xattr $REISERFS_MOUNT_OPTIONS"
260                 ;;
261         gfs2)
262                 # acls aren't turned on by default on gfs2
263                 export MOUNT_OPTIONS="-o acl $GFS2_MOUNT_OPTIONS"
264                 ;;
265         tmpfs)
266                 # We need to specify the size at mount, use 512 MB by default
267                 export MOUNT_OPTIONS="-o size=512M $TMPFS_MOUNT_OPTIONS"
268                 ;;
269         *)
270                 ;;
271         esac
272 }
273
274 _test_mount_opts()
275 {
276         case $FSTYP in
277         cifs)
278                 export TEST_FS_MOUNT_OPTS=$CIFS_MOUNT_OPTIONS
279                 ;;
280         *)
281                 ;;
282         esac
283 }
284
285 _mkfs_opts()
286 {
287         case $FSTYP in
288         xfs)
289                 export MKFS_OPTIONS=$XFS_MKFS_OPTIONS
290                 ;;
291         udf)
292                 [ ! -z "$udf_fsize" ] && \
293                         UDF_MKFS_OPTIONS="$UDF_MKFS_OPTIONS -s $udf_fsize"
294                 export MKFS_OPTIONS=$UDF_MKFS_OPTIONS
295                 ;;
296         nfs)
297                 export MKFS_OPTIONS=$NFS_MKFS_OPTIONS
298                 ;;
299         cifs)
300                 export MKFS_OPTIONS=$CIFS_MKFS_OPTIONS
301                 ;;
302         reiserfs)
303                 export MKFS_OPTIONS="$REISERFS_MKFS_OPTIONS -q"
304                 ;;
305         gfs2)
306                 export MKFS_OPTIONS="$GFS2_MKFS_OPTIONS -O -p lock_nolock"
307                 ;;
308         jfs)
309                 export MKFS_OPTIONS="$JFS_MKFS_OPTIONS -q"
310                 ;;
311         *)
312                 ;;
313         esac
314 }
315
316 _fsck_opts()
317 {
318         case $FSTYP in
319         ext2|ext3|ext4|ext4dev)
320                 export FSCK_OPTIONS="-nf"
321                 ;;
322         reiserfs)
323                 export FSCK_OPTIONS="--yes"
324                 ;;
325         *)
326                 export FSCK_OPTIONS="-n"
327                 ;;
328         esac
329 }
330
331 known_hosts()
332 {
333         [ "$HOST_CONFIG_DIR" ] || HOST_CONFIG_DIR=`pwd`/configs
334
335         [ -f /etc/xfsqa.config ]             && export HOST_OPTIONS=/etc/xfsqa.config
336         [ -f $HOST_CONFIG_DIR/$HOST ]        && export HOST_OPTIONS=$HOST_CONFIG_DIR/$HOST
337         [ -f $HOST_CONFIG_DIR/$HOST.config ] && export HOST_OPTIONS=$HOST_CONFIG_DIR/$HOST.config
338 }
339
340 # Returns a list of sections in config file
341 # Each section starts with the section name in the format
342 # [section_name1]. Only alphanumeric characters and '_' is allowed
343 # in the section name otherwise the section will not be resognised.
344 # Section name must be contained between square brackets.
345 get_config_sections() {
346         sed -n -e "s/^\[\([[:alnum:]_]*\)\]/\1/p" < $1
347 }
348
349 if [ ! -f "$HOST_OPTIONS" ]; then
350         known_hosts
351 fi
352
353 export HOST_OPTIONS_SECTIONS="-no-sections-"
354 export OPTIONS_HAVE_SECTIONS=false
355 if [ -f "$HOST_OPTIONS" ]; then
356         export HOST_OPTIONS_SECTIONS=`get_config_sections $HOST_OPTIONS`
357         if [ -z "$HOST_OPTIONS_SECTIONS" ]; then
358                 . $HOST_OPTIONS
359                 export HOST_OPTIONS_SECTIONS="-no-sections-"
360         else
361                 export OPTIONS_HAVE_SECTIONS=true
362         fi
363 fi
364
365 # Parse config section options. This function will parse all the configuration
366 # within a single section which name is passed as an argument. For section
367 # name format see comments in get_config_sections().
368 # Empty lines and everything after '#' will be ignored.
369 # Configuration options should be defined in the format
370 #
371 # CONFIG_OPTION=value
372 #
373 # This 'CONFIG_OPTION' variable and will be exported as an environment variable.
374 parse_config_section() {
375         SECTION=$1
376         if ! $OPTIONS_HAVE_SECTIONS; then
377                 return 0
378         fi
379         eval `sed -e 's/[[:space:]]*\=[[:space:]]*/=/g' \
380                 -e 's/#.*$//' \
381                 -e 's/[[:space:]]*$//' \
382                 -e 's/^[[:space:]]*//' \
383                 -e "s/^\([^=]*\)=\"\?'\?\([^\"']*\)\"\?'\?$/export \1=\"\2\"/" \
384                 < $HOST_OPTIONS \
385                 | sed -n -e "/^\[$SECTION\]/,/^\s*\[/{/^[^#].*\=.*/p;}"`
386 }
387
388 get_next_config() {
389         if [ ! -z "$CONFIG_INCLUDED" ] && ! $OPTIONS_HAVE_SECTIONS; then
390                 return 0
391         fi
392
393         local OLD_FSTYP=$FSTYP
394         local OLD_MOUNT_OPTIONS=$MOUNT_OPTIONS
395         local OLD_TEST_FS_MOUNT_OPTS=$TEST_FS_MOUNT_OPTS
396         local OLD_MKFS_OPTIONS=$MKFS_OPTIONS
397         local OLD_FSCK_OPTIONS=$FSCK_OPTIONS
398
399         unset MOUNT_OPTIONS
400         unset MKFS_OPTIONS
401         unset FSCK_OPTIONS
402         # We might have deduced SCRATCH_DEV from the SCRATCH_DEV_POOL in the previous
403         # run, so we have to unset it now.
404         if [ "$SCRATCH_DEV_NOT_SET" == "true" ]; then
405                 unset SCRATCH_DEV
406         fi
407
408         parse_config_section $1
409
410         if [ ! -z "$OLD_FSTYP" ] && [ $OLD_FSTYP != $FSTYP ]; then
411                 [ -z "$MOUNT_OPTIONS" ] && _mount_opts
412                 [ -z "$TEST_FS_MOUNT_OPTS" ] && _test_mount_opts
413                 [ -z "$MKFS_OPTIONS" ] && _mkfs_opts
414                 [ -z "$FSCK_OPTIONS" ] && _fsck_opts
415         else
416                 [ -z "$MOUNT_OPTIONS" ] && export MOUNT_OPTIONS=$OLD_MOUNT_OPTIONS
417                 [ -z "$TEST_FS_MOUNT_OPTS" ] && export TEST_FS_MOUNT_OPTS=$OLD_TEST_FS_MOUNT_OPTS
418                 [ -z "$MKFS_OPTIONS" ] && export MKFS_OPTIONS=$OLD_MKFS_OPTIONS
419                 [ -z "$FSCK_OPTIONS" ] && export FSCK_OPTIONS=$OLD_FSCK_OPTIONS
420         fi
421
422         # set default RESULT_BASE
423         if [ -z "$RESULT_BASE" ]; then
424                 export RESULT_BASE="$here/results/"
425         fi
426
427         #  Mandatory Config values.
428         MC=""
429         [ -z "$EMAIL" ]          && MC="$MC EMAIL"
430         [ -z "$TEST_DIR" ]       && MC="$MC TEST_DIR"
431         [ -z "$TEST_DEV" ]       && MC="$MC TEST_DEV"
432
433         if [ -n "$MC" ]; then
434                 echo "Warning: need to define parameters for host $HOST"
435                 echo "       or set variables:"
436                 echo "       $MC"
437                 exit 1
438         fi
439
440         echo $TEST_DEV | grep -qE ":|//" > /dev/null 2>&1
441         if [ ! -b "$TEST_DEV" -a "$?" != "0" ]; then
442                 echo "common/config: Error: \$TEST_DEV ($TEST_DEV) is not a block device or a network filesystem"
443                 exit 1
444         fi
445
446         if [ ! -d "$TEST_DIR" ]; then
447                 echo "common/config: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
448                 exit 1
449         fi
450
451         # a btrfs tester will set only SCRATCH_DEV_POOL, we will put first of its dev
452         # to SCRATCH_DEV and rest to SCRATCH_DEV_POOL to maintain the backward compatibility
453         if [ ! -z "$SCRATCH_DEV_POOL" ]; then
454                 if [ ! -z "$SCRATCH_DEV" ]; then
455                         echo "common/config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) should be unset when \$SCRATCH_DEV_POOL ($SCRATCH_DEV_POOL) is set"
456                         exit 1
457                 fi
458                 SCRATCH_DEV=`echo $SCRATCH_DEV_POOL | awk '{print $1}'`
459                 export SCRATCH_DEV
460                 export SCRATCH_DEV_NOT_SET=true
461         fi
462
463         echo $SCRATCH_DEV | grep -qE ":|//" > /dev/null 2>&1
464         if [ ! -z "$SCRATCH_DEV" -a ! -b "$SCRATCH_DEV" -a "$?" != "0" ]; then
465                 echo "common/config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) is not a block device or a network filesystem"
466                 exit 1
467         fi
468
469         if [ ! -z "$SCRATCH_MNT" -a ! -d "$SCRATCH_MNT" ]; then
470                 echo "common/config: Error: \$SCRATCH_MNT ($SCRATCH_MNT) is not a directory"
471                 exit 1
472         fi
473 }
474
475 if [ -z "$CONFIG_INCLUDED" ]; then
476         get_next_config `echo $HOST_OPTIONS_SECTIONS | cut -f1 -d" "`
477         export CONFIG_INCLUDED=true
478
479         # Autodetect fs type based on what's on $TEST_DEV unless it's been set
480         # externally
481         if [ -z "$FSTYP" ] && \
482            [ "$HOSTOS" == "Linux" -o "$OSTYPE" == "linux-gnu" ] && \
483            [ ! -z "$TEST_DEV" ]; then
484                 FSTYP=`blkid -c /dev/null -s TYPE -o value $TEST_DEV`
485         fi
486         FSTYP=${FSTYP:=xfs}
487         export FSTYP
488         [ -z "$MOUNT_OPTIONS" ] && _mount_opts
489         [ -z "$TEST_FS_MOUNT_OPTS" ] && _test_mount_opts
490         [ -z "$MKFS_OPTIONS" ] && _mkfs_opts
491         [ -z "$FSCK_OPTIONS" ] && _fsck_opts
492 fi
493
494 # make sure this script returns success
495 /bin/true